<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Flair: io_data.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Flair
   </div>
   <div id="projectbrief">Framework Libre Air</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('io__data_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">io_data.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="io__data_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// %flair:license{</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// This file is part of the Flair framework distributed under the</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// CECILL-C License, Version 1.0.</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// %flair:license}</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"></span><span class="preprocessor">#ifndef IO_DATA_H</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#define IO_DATA_H</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_mutex_8h.html">Mutex.h</a>&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">class </span>IODevice_impl;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">class </span>io_data_impl;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceflair.html">flair</a> {</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">namespace </span>core {</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">class </span>Object;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div>
<div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="classflair_1_1core_1_1_data_type.html">   26</a></span>&#160;<span class="keyword">class </span><a class="code" href="classflair_1_1core_1_1_data_type.html">DataType</a> {</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;  <span class="keyword">virtual</span> std::string GetDescription() <span class="keyword">const</span> = 0;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;  <span class="comment">// size in bytes</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> GetSize() <span class="keyword">const</span> = 0;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;};</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div>
<div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="classflair_1_1core_1_1_dummy_type.html">   33</a></span>&#160;<span class="keyword">class </span><a class="code" href="classflair_1_1core_1_1_dummy_type.html">DummyType</a> : <span class="keyword">public</span> <a class="code" href="classflair_1_1core_1_1_data_type.html">DataType</a> {</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;  <span class="keywordtype">size_t</span> GetSize()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;  std::string GetDescription()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;dummy&quot;</span>; };</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;};</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="keyword">extern</span> <a class="code" href="classflair_1_1core_1_1_dummy_type.html">DummyType</a> dummyType;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="classflair_1_1core_1_1_scalar_type.html">   40</a></span>&#160;<span class="keyword">class </span><a class="code" href="classflair_1_1core_1_1_scalar_type.html">ScalarType</a> : <span class="keyword">public</span> <a class="code" href="classflair_1_1core_1_1_data_type.html">DataType</a> {</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;  <a class="code" href="classflair_1_1core_1_1_scalar_type.html">ScalarType</a>(<span class="keywordtype">size_t</span> _size) : size(_size) {}</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;  <span class="keywordtype">size_t</span> GetSize()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> size; }</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;  <span class="keyword">virtual</span> std::string GetDescription()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;scalar&quot;</span>; };</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;  <span class="keywordtype">size_t</span> size;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;};</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div>
<div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="classflair_1_1core_1_1_signed_integer_type.html">   50</a></span>&#160;<span class="keyword">class </span><a class="code" href="classflair_1_1core_1_1_signed_integer_type.html">SignedIntegerType</a> : <span class="keyword">public</span> <a class="code" href="classflair_1_1core_1_1_scalar_type.html">ScalarType</a> {</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;  <a class="code" href="classflair_1_1core_1_1_signed_integer_type.html">SignedIntegerType</a>(<span class="keywordtype">size_t</span> sizeInBits) : <a class="code" href="classflair_1_1core_1_1_scalar_type.html">ScalarType</a>(sizeInBits / 8) {}</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;  std::string GetDescription()<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordflow">return</span> <span class="stringliteral">&quot;int&quot;</span> + std::to_string(GetSize() * 8) + <span class="stringliteral">&quot;_t&quot;</span>;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;  };</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;};</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="keyword">extern</span> <a class="code" href="classflair_1_1core_1_1_signed_integer_type.html">SignedIntegerType</a> Int8Type;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="keyword">extern</span> <a class="code" href="classflair_1_1core_1_1_signed_integer_type.html">SignedIntegerType</a> Int16Type;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div>
<div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="classflair_1_1core_1_1_unsigned_integer_type.html">   60</a></span>&#160;<span class="keyword">class </span><a class="code" href="classflair_1_1core_1_1_unsigned_integer_type.html">UnsignedIntegerType</a> : <span class="keyword">public</span> <a class="code" href="classflair_1_1core_1_1_scalar_type.html">ScalarType</a> {</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;  <a class="code" href="classflair_1_1core_1_1_unsigned_integer_type.html">UnsignedIntegerType</a>(<span class="keywordtype">size_t</span> sizeInBits) : <a class="code" href="classflair_1_1core_1_1_scalar_type.html">ScalarType</a>(sizeInBits / 8) {}</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;  std::string GetDescription()<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keywordflow">return</span> <span class="stringliteral">&quot;uint&quot;</span> + std::to_string(GetSize() * 8) + <span class="stringliteral">&quot;_t&quot;</span>;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;  };</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;};</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="keyword">extern</span> <a class="code" href="classflair_1_1core_1_1_unsigned_integer_type.html">UnsignedIntegerType</a> UInt8Type;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="keyword">extern</span> <a class="code" href="classflair_1_1core_1_1_unsigned_integer_type.html">UnsignedIntegerType</a> UInt16Type;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div>
<div class="line"><a name="l00070"></a><span class="lineno"><a class="line" href="classflair_1_1core_1_1_float_type.html">   70</a></span>&#160;<span class="keyword">class </span><a class="code" href="classflair_1_1core_1_1_float_type.html">FloatType</a> : <span class="keyword">public</span> <a class="code" href="classflair_1_1core_1_1_scalar_type.html">ScalarType</a> {</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;  <a class="code" href="classflair_1_1core_1_1_float_type.html">FloatType</a>() : <a class="code" href="classflair_1_1core_1_1_scalar_type.html">ScalarType</a>(4) {}</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;  std::string GetDescription()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;float&quot;</span>; };</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;};</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="keyword">extern</span> <a class="code" href="classflair_1_1core_1_1_float_type.html">FloatType</a> floatType;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div>
<div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="classflair_1_1core_1_1_double_type.html">   77</a></span>&#160;<span class="keyword">class </span><a class="code" href="classflair_1_1core_1_1_double_type.html">DoubleType</a> : <span class="keyword">public</span> <a class="code" href="classflair_1_1core_1_1_scalar_type.html">ScalarType</a> {</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;  <a class="code" href="classflair_1_1core_1_1_double_type.html">DoubleType</a>() : <a class="code" href="classflair_1_1core_1_1_scalar_type.html">ScalarType</a>(8) {}</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;  std::string GetDescription()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;double&quot;</span>; };</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;};</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="keyword">extern</span> <a class="code" href="classflair_1_1core_1_1_double_type.html">DoubleType</a> doubleType;</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div>
<div class="line"><a name="l00094"></a><span class="lineno"><a class="line" href="classflair_1_1core_1_1io__data.html">   94</a></span>&#160;<span class="keyword">class </span><a class="code" href="classflair_1_1core_1_1io__data.html">io_data</a> : <span class="keyword">public</span> <a class="code" href="classflair_1_1core_1_1_mutex.html">Mutex</a> {</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;  <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classflair_1_1core_1_1_i_o_device.html">IODevice</a>;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;  <span class="keyword">friend</span> class ::IODevice_impl;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;  <span class="keyword">friend</span> class ::io_data_impl;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;  <a class="code" href="classflair_1_1core_1_1io__data.html#a8f1ba8c576e0a94bb27bdf1b6d1f7d21">io_data</a>(<span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1_object.html">Object</a> *parent, std::string name, <span class="keywordtype">int</span> n);</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;  <span class="keyword">virtual</span> <a class="code" href="classflair_1_1core_1_1io__data.html#a63b4bbba0120e45d69d616f7b7cb021a">~io_data</a>();</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1io__data.html#acae3fb98b266a788b12083c7eec2be10">SetDataTime</a>(<a class="code" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> time);</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;  </div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1io__data.html#acae3fb98b266a788b12083c7eec2be10">SetDataTime</a>(<a class="code" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> time,<a class="code" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> deltaTime);</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;  <a class="code" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> <a class="code" href="classflair_1_1core_1_1io__data.html#a9481c27408747e9392d9425f45699599">DataTime</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;  </div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;  <a class="code" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> <a class="code" href="classflair_1_1core_1_1io__data.html#aba2a52aae7efbcd769820cde4e1a38d9">DataDeltaTime</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;  </div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1io__data.html#a02cd00111e4b93187b668de49cdec642">GetDataTime</a>(<a class="code" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> &amp;time,<a class="code" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> &amp;deltaTime) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;  <span class="keyword">const</span> <a class="code" href="classflair_1_1core_1_1io__data.html">io_data</a> *<a class="code" href="classflair_1_1core_1_1io__data.html#a6337ffd87caf22391c4484da3fc13d47">Prev</a>(<span class="keywordtype">int</span> n) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;  <span class="keyword">virtual</span> <a class="code" href="classflair_1_1core_1_1_data_type.html">DataType</a> <span class="keyword">const</span> &amp;GetDataType() <span class="keyword">const</span> = 0;</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;  </div>
<div class="line"><a name="l00186"></a><span class="lineno"><a class="line" href="classflair_1_1core_1_1io__data.html#aa81cc1713a594806040a1e5d52ec9fa3">  186</a></span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1io__data.html#aa81cc1713a594806040a1e5d52ec9fa3">RawWrite</a>(<span class="keywordtype">char</span> *src)  {};<span class="comment">//todo put pure virtual</span></div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;  </div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;  <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1io__data.html#aa590e14a9fb18a1ffc5d4dbed85f46c4">RawRead</a>(<span class="keywordtype">char</span> *dst) <span class="keyword">const</span> = 0;</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1io__data.html#acc7fc08f29ba17fed5b94150826fae2d">AppendLogDescription</a>(std::string description, <a class="code" href="classflair_1_1core_1_1_data_type.html">DataType</a> <span class="keyword">const</span> &amp;datatype);</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;  <span class="keywordtype">void</span> <a class="code" href="classflair_1_1core_1_1io__data.html#aa8b8c20d94aaf6b9eb4e21e2b95d51b2">SetPtrToCircle</a>(<span class="keywordtype">void</span> **ptr);</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;</div>
<div class="line"><a name="l00229"></a><span class="lineno"><a class="line" href="classflair_1_1core_1_1io__data.html#a58e1a3f2fbf1655a047268375ba2202e">  229</a></span>&#160;  <a class="code" href="classflair_1_1core_1_1io__data.html">io_data</a> *<a class="code" href="classflair_1_1core_1_1io__data.html#a58e1a3f2fbf1655a047268375ba2202e">prev</a>;</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;  io_data_impl *pimpl_;</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;};</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;} <span class="comment">// end namespace core</span></div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;} <span class="comment">// end namespace flair</span></div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;<span class="preprocessor">#endif // IO_DATA_H</span></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html">flair::core::io_data</a></div><div class="ttdoc">Abstract class for data types. </div><div class="ttdef"><b>Definition:</b> io_data.h:94</div></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html_a6337ffd87caf22391c4484da3fc13d47"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html#a6337ffd87caf22391c4484da3fc13d47">flair::core::io_data::Prev</a></div><div class="ttdeci">const io_data * Prev(int n) const </div><div class="ttdoc">Previous data. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_data_type_html"><div class="ttname"><a href="classflair_1_1core_1_1_data_type.html">flair::core::DataType</a></div><div class="ttdef"><b>Definition:</b> io_data.h:26</div></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html_aba2a52aae7efbcd769820cde4e1a38d9"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html#aba2a52aae7efbcd769820cde4e1a38d9">flair::core::io_data::DataDeltaTime</a></div><div class="ttdeci">Time DataDeltaTime(void) const </div><div class="ttdoc">Data delta time. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_object_html"><div class="ttname"><a href="classflair_1_1core_1_1_object.html">flair::core::Object</a></div><div class="ttdoc">Base class for all Framework&#39;s classes. </div><div class="ttdef"><b>Definition:</b> Object.h:83</div></div>
<div class="ttc" id="classflair_1_1core_1_1_i_o_device_html"><div class="ttname"><a href="classflair_1_1core_1_1_i_o_device.html">flair::core::IODevice</a></div><div class="ttdoc">Abstract class for input/ouput system. </div><div class="ttdef"><b>Definition:</b> IODevice.h:45</div></div>
<div class="ttc" id="namespaceflair_html"><div class="ttname"><a href="namespaceflair.html">flair</a></div><div class="ttdoc">namespace of the flair Framework </div><div class="ttdef"><b>Definition:</b> Ahrs.h:19</div></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html_a9481c27408747e9392d9425f45699599"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html#a9481c27408747e9392d9425f45699599">flair::core::io_data::DataTime</a></div><div class="ttdeci">Time DataTime(void) const </div><div class="ttdoc">Data time. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_mutex_html"><div class="ttname"><a href="classflair_1_1core_1_1_mutex.html">flair::core::Mutex</a></div><div class="ttdoc">Class defining a mutex. </div><div class="ttdef"><b>Definition:</b> Mutex.h:29</div></div>
<div class="ttc" id="namespaceflair_1_1core_html_acc0fa041e08ecf73b2d1d723c339a736"><div class="ttname"><a href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">flair::core::Time</a></div><div class="ttdeci">unsigned long long Time</div><div class="ttdoc">Time definition, in ns. </div><div class="ttdef"><b>Definition:</b> Object.h:55</div></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html_aa81cc1713a594806040a1e5d52ec9fa3"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html#aa81cc1713a594806040a1e5d52ec9fa3">flair::core::io_data::RawWrite</a></div><div class="ttdeci">virtual void RawWrite(char *src)</div><div class="ttdoc">Raw write datas. </div><div class="ttdef"><b>Definition:</b> io_data.h:186</div></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html_aa8b8c20d94aaf6b9eb4e21e2b95d51b2"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html#aa8b8c20d94aaf6b9eb4e21e2b95d51b2">flair::core::io_data::SetPtrToCircle</a></div><div class="ttdeci">void SetPtrToCircle(void **ptr)</div><div class="ttdoc">Set the datas to circle. </div></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html_a58e1a3f2fbf1655a047268375ba2202e"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html#a58e1a3f2fbf1655a047268375ba2202e">flair::core::io_data::prev</a></div><div class="ttdeci">io_data * prev</div><div class="ttdoc">Pointer to previous data. </div><div class="ttdef"><b>Definition:</b> io_data.h:229</div></div>
<div class="ttc" id="classflair_1_1core_1_1_scalar_type_html"><div class="ttname"><a href="classflair_1_1core_1_1_scalar_type.html">flair::core::ScalarType</a></div><div class="ttdef"><b>Definition:</b> io_data.h:40</div></div>
<div class="ttc" id="classflair_1_1core_1_1_double_type_html"><div class="ttname"><a href="classflair_1_1core_1_1_double_type.html">flair::core::DoubleType</a></div><div class="ttdef"><b>Definition:</b> io_data.h:77</div></div>
<div class="ttc" id="classflair_1_1core_1_1_dummy_type_html"><div class="ttname"><a href="classflair_1_1core_1_1_dummy_type.html">flair::core::DummyType</a></div><div class="ttdef"><b>Definition:</b> io_data.h:33</div></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html_acae3fb98b266a788b12083c7eec2be10"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html#acae3fb98b266a788b12083c7eec2be10">flair::core::io_data::SetDataTime</a></div><div class="ttdeci">void SetDataTime(Time time)</div><div class="ttdoc">Set data time, also caluculates the delta time based on last call. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_unsigned_integer_type_html"><div class="ttname"><a href="classflair_1_1core_1_1_unsigned_integer_type.html">flair::core::UnsignedIntegerType</a></div><div class="ttdef"><b>Definition:</b> io_data.h:60</div></div>
<div class="ttc" id="_mutex_8h_html"><div class="ttname"><a href="_mutex_8h.html">Mutex.h</a></div><div class="ttdoc">Class defining a mutex. </div></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html_a8f1ba8c576e0a94bb27bdf1b6d1f7d21"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html#a8f1ba8c576e0a94bb27bdf1b6d1f7d21">flair::core::io_data::io_data</a></div><div class="ttdeci">io_data(const Object *parent, std::string name, int n)</div><div class="ttdoc">Constructor. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_signed_integer_type_html"><div class="ttname"><a href="classflair_1_1core_1_1_signed_integer_type.html">flair::core::SignedIntegerType</a></div><div class="ttdef"><b>Definition:</b> io_data.h:50</div></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html_acc7fc08f29ba17fed5b94150826fae2d"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html#acc7fc08f29ba17fed5b94150826fae2d">flair::core::io_data::AppendLogDescription</a></div><div class="ttdeci">void AppendLogDescription(std::string description, DataType const &amp;datatype)</div><div class="ttdoc">Specify the description of the reimplemented class data&#39;s. </div></div>
<div class="ttc" id="classflair_1_1core_1_1_float_type_html"><div class="ttname"><a href="classflair_1_1core_1_1_float_type.html">flair::core::FloatType</a></div><div class="ttdef"><b>Definition:</b> io_data.h:70</div></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html_a63b4bbba0120e45d69d616f7b7cb021a"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html#a63b4bbba0120e45d69d616f7b7cb021a">flair::core::io_data::~io_data</a></div><div class="ttdeci">virtual ~io_data()</div><div class="ttdoc">Destructor. </div></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html_a02cd00111e4b93187b668de49cdec642"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html#a02cd00111e4b93187b668de49cdec642">flair::core::io_data::GetDataTime</a></div><div class="ttdeci">void GetDataTime(Time &amp;time, Time &amp;deltaTime) const </div><div class="ttdoc">Get data time and delta time. </div></div>
<div class="ttc" id="classflair_1_1core_1_1io__data_html_aa590e14a9fb18a1ffc5d4dbed85f46c4"><div class="ttname"><a href="classflair_1_1core_1_1io__data.html#aa590e14a9fb18a1ffc5d4dbed85f46c4">flair::core::io_data::RawRead</a></div><div class="ttdeci">virtual void RawRead(char *dst) const =0</div><div class="ttdoc">Raw read datas. </div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_33c2ee9b1665499374b4225c427cf176.html">igep</a></li><li class="navelem"><a class="el" href="dir_f1fe274389177bd7e17de7949c4ffada.html">flair-src</a></li><li class="navelem"><a class="el" href="dir_3ef62148cf94871b4b6ee5d6e3a989c1.html">lib</a></li><li class="navelem"><a class="el" href="dir_97265977dbbd48c696782ccac102bad5.html">FlairCore</a></li><li class="navelem"><a class="el" href="dir_6c198461db290ac9abcdd44184573216.html">src</a></li><li class="navelem"><a class="el" href="io__data_8h.html">io_data.h</a></li>
    <li class="footer">Generated on Thu Jan 31 2019 12:34:23 for Flair by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.9.1 </li>
  </ul>
</div>
</body>
</html>
